package com.zcloud.personnel.positioning.command;

import com.zcloud.personnel.positioning.domain.gateway.AlarmRuleFenceRelGateway;
import com.zcloud.personnel.positioning.domain.model.AlarmRuleFenceRelE;
import com.zcloud.personnel.positioning.dto.AlarmRuleFenceRelAddCmd;
import com.alibaba.cola.exception.BizException;
import lombok.AllArgsConstructor;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

/**
 * web-app
 *
 * @Author fangjiakai
 * @Date 2026-07-07
 */
@Component
@AllArgsConstructor
public class AlarmRuleFenceRelAddExe {
    private final AlarmRuleFenceRelGateway alarmRuleFenceRelGateway;

    @Transactional(rollbackFor = Exception.class)
    public boolean execute(AlarmRuleFenceRelAddCmd cmd) {
        AlarmRuleFenceRelE alarmRuleFenceRelE = new AlarmRuleFenceRelE();
        BeanUtils.copyProperties(cmd, alarmRuleFenceRelE);
        boolean res;
        try {
            res = alarmRuleFenceRelGateway.add(alarmRuleFenceRelE);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        if (!res) {
            throw new BizException("保存失败");
        }
        return true;
    }
}
